/*
 * PrivateWorldManager Tyler 1998-2000.
 */

   public class PrivateWorldManager {
      // static stuff...
      static PrivateWorld[] private_world;
      static PrivateWorld[] new_private_world;
   
      static int max_number_of_private_worlds = 16;
      static int number_of_private_worlds;
   
      static int agent_counter;
      static int shift = Entity.shift;
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
   
      static int temp_x, temp_y, temp_radius;
   
      static PrivateWorld pw;
      static PrivateWorld pw_from;
      static PrivateWorld temp_private_world;
   
      static Entity pw_entity;
      static Entity temp_entity;
      static Entity temp_entity2;
   
      static Link temp_link;
      static Link temp_link2;
   
      static Creature temp_creature;
   
      // PrivateWorldManager() {
         //private_world = new PrivateWorld[max_number_of_private_worlds];
         //number_of_private_worlds = 0;
      //}
   
      final static void initial() {
         private_world = new PrivateWorld[max_number_of_private_worlds];
         number_of_private_worlds = 0;
         if (Shoals.initial_type != Shoals._MIXTURE) {
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals.initial_type));
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals.initial_type));
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals.initial_type));
         }
         else
         {
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals._TADPOLES));
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals._SPERM));
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals._SMALLSPINES));
            makeAnEgg(Shoals.entity_manager.getCreatureDescription(Shoals._SMALLAMOEBA));
         }
      }
   
   
      final static void makeAnEgg(String _desc) {
         pw_entity = Shoals.entity_manager.addNewAgent(10000, 10000, (char)511, (byte)96, (byte)15, Entity.DRAG | Entity.ALWAYS_CIRCULAR | Entity.ALWAYS_HOLLOW); //  | Entity.ALWAYS_HOLLOW);
      
         pw = associateNewPrivateWorldWith(pw_entity);
      
         Shoals_Input.addFromString(_desc, pw, 0, 0, 256);
      
         pw.addNewAgent(100, 100, (char)127, (byte)10, (byte)18, Entity.ALWAYS_CIRCULAR | Entity.ALWAYS_HOLLOW);
      
         pw.addNewAgent(100, 100, (char)127, (byte)13, (byte)17, Entity.ALWAYS_CIRCULAR | Entity.ALWAYS_HOLLOW);
      
         pw.addNewAgent(100, 100, (char)127, (byte)20, (byte)16, Entity.ALWAYS_CIRCULAR | Entity.ALWAYS_HOLLOW);
      }
   
   
      final static void reset() {
         // debug("KILLING " + number_of_private_worlds + " WORLDS");
      
         for (temp = 0; temp < number_of_private_worlds; temp++) {
            private_world[temp].reset();
         }
      
         number_of_private_worlds = 0;
      }
   
   
      final static PrivateWorld associateNewPrivateWorldWith(Entity e1) {
         if (number_of_private_worlds >= max_number_of_private_worlds) {
            makeMorePrivateWorlds();
         }
      
         if (private_world[number_of_private_worlds] == null) {
            private_world[number_of_private_worlds] = new PrivateWorld(e1);
         }
         else
         {
            private_world[number_of_private_worlds].set(e1);
         }
      
         e1.status |= Entity.HAS_INNER_WORLD;
      
         return private_world[number_of_private_worlds++];
      }
   
   
      final static void makeMorePrivateWorlds() {
      
         max_number_of_private_worlds++;
      
         new_private_world = new PrivateWorld[max_number_of_private_worlds];
      
         for (temp = 0; temp < (max_number_of_private_worlds - 1); temp++) {
            new_private_world[temp] = private_world[temp];
         }
      
         private_world = new_private_world;
      }
   
   
      final static void draw() {
      }
   
   
      final static void scrub() {
      }
   
   
      final static void update() {
      }
   
   
      final static void unbufferedUpdate() {
         for (temp = 0; temp < (number_of_private_worlds); temp++) {
            private_world[temp].unbufferedUpdate();
         }
      }
   
   
      final static void bufferedUpdate() {
      
         for (temp = 0; temp < (number_of_private_worlds); temp++) {
            private_world[temp].bufferedUpdate();
         }
      }
   
   /*
      // maximum value check....
      final void setLink(Entity e1, Entity e2, int l, int e) {
         if (number_of_private_worlds >= max_number_of_private_worlds) {
            makeMorePrivateWorlds();
         }
      
         if (private_world[number_of_private_worlds] == null) {
            private_world[number_of_private_worlds] = new PrivateWorld(e1, e2, l, e);
         }
         else
         {
            private_world[number_of_private_worlds].set(e1, e2, l, e);
         }
      
      	// add this link to the list of links associated with the entity...
         e1.addLink(private_world[number_of_private_worlds]);
         e2.addLink(private_world[number_of_private_worlds++]);
      }
   */
   
   
   // wotz this for??
      // maximum value check....
   /*
      final static void setLink() {
         if (number_of_private_worlds >= max_number_of_private_worlds) {
            makeMorePrivateWorlds();
         }
      
         // temp_entity = new Entity();
      
         if (private_world[number_of_private_worlds] == null) {
            // private_world[number_of_private_worlds++] = new PrivateWorld(temp_entity,temp_entity, 0, 0);
            private_world[number_of_private_worlds++] = new PrivateWorld(); // null, null, 0, 0);
         }
         else
         {
            // private_world[number_of_private_worlds++].set(temp_entity,temp_entity, 0, 0);
            // private_world[number_of_private_worlds++].set(); // null,null, 0, 0);
         }
      }
   */
   
      final static PrivateWorld getPrivateWorldAssociatedWith(Entity e) {
         for (temp = 0; temp < number_of_private_worlds; temp++) {
            temp_private_world = private_world[temp];
            // if (temp_private_world.contains(e)) {
            if (temp_private_world.associated_entity == e) {
               return temp_private_world;
            }
         }
      
         debug("Couldn't find the PrivateWorld associated with this entity :-(");
         // do { } while (true);
         return null;
      }
   
   
   // EXPERIMENT FURTHER WITH THIS - USE A SWAP...
      final static void copyEverythingOut(Entity e, PrivateWorld pw_to) {
         pw_from = getPrivateWorldAssociatedWith(e);
         pw_from.scrub(); // any problems here?
      
         if (pw_from.number_of_agents > 0) { // needed?
            //debug("pw_from.number_of_agents:" + pw_from.number_of_agents);
            for (temp = 0; temp < pw_from.number_of_agents; temp++) {
               if (pw_to.number_of_agents >= pw_to.max_number_of_agents) {
                  pw_to.makeMoreEntities();
               }
            
               temp_entity = pw_from.agent[temp];
               pw_from.agent[temp] = pw_to.agent[pw_to.number_of_agents];
               pw_to.agent[pw_to.number_of_agents++] = temp_entity;
            }
         }
      
         if (pw_from.link_manager.number_of_links > 0) {
            //debug("pw_from.link_manager.number_of_links:" + pw_from.link_manager.number_of_links);
            for (temp = 0; temp < pw_from.link_manager.number_of_links; temp++) {
               if (pw_to.link_manager.number_of_links >= pw_to.link_manager.max_number_of_links) {
                  pw_to.link_manager.makeMoreLinks();
               }
            
               temp_link = pw_from.link_manager.entity_link[temp];
               pw_from.link_manager.entity_link[temp] = pw_to.link_manager.entity_link[pw_to.link_manager.number_of_links];
               pw_to.link_manager.entity_link[pw_to.link_manager.number_of_links++] = temp_link;
            }
         }
      
         // Shoals.entity_manager.creature_manager.moveCreaturesBetweenWorlds2(pw_from, pw_to); // needs care...
         moveCreaturesBetweenWorlds(pw_from, pw_to); // needs care...
      
         killSpecifiedPrivateWorld(pw_from);
      }
   
   
      final static void moveCreaturesBetweenWorlds(PrivateWorld _pw_from, PrivateWorld _pw_to) {
         for (temp = _pw_from.creature_manager.number_of_creatures; --temp >= 0; ) {
            temp_creature = _pw_to.creature_manager.add();
         
            temp_creature.private_world = _pw_from;
            _pw_from.creature_manager.creature[temp].private_world = _pw_to;
         
            _pw_to.creature_manager.creature[_pw_to.creature_manager.number_of_creatures - 1] = _pw_from.creature_manager.creature[temp];
            _pw_from.creature_manager.creature[temp] = temp_creature;
         } 
      }
   
   
   /*
   // works...
      final static void copyEverythingOut(Entity e, PrivateWorld pw_to) {
         pw_from = getPrivateWorldAssociatedWith(e);
         pw_from.scrub(); // problems here?
      
         int initial_entity_number = pw_to.number_of_agents;
      
         // *must* go forwards...
         for (temp = 0; temp < pw_from.number_of_agents; temp++) {
            temp_entity = pw_from.agent[temp];
         
            temp_entity2 = pw_to.copy(temp_entity);
            temp_entity2.setInitialSize(temp_entity.diameter, temp_entity.target_diameter); // should not be needed...
         }
      
         for (temp = 0; temp < pw_from.number_of_agents; temp++) {
            temp_entity = pw_from.agent[temp];
            temp3 = temp_entity.list_of_links.number_of_links;
         
            for (temp2 = temp3; --temp2 >= 0; ) {
               temp_link = temp_entity.list_of_links.link[temp2];
            
               temp4 = pw_from.getEntityNumber(temp_link.entity1);
               temp5 = pw_from.getEntityNumber(temp_link.entity2);
            
               if (temp4 < 0) debug("temp4 < 0 ."); // that's /probably/ OK - the link may have been destroyed
               if (temp5 < 0) debug("temp5 < 0 ."); // while still inside the private world...
            
               if (temp4 >= 0) { // part of the problem...
                  if (temp5 >= 0) { // part of the problem...
                     if (!pw_to.link_manager.thereIsALinkBetween(pw_to.agent[temp4 + initial_entity_number],pw_to.agent[temp5 + initial_entity_number])) {
                        pw_to.link_manager.setLink(pw_to.agent[temp4 + initial_entity_number],pw_to.agent[temp5 + initial_entity_number], temp_link.lower_length_limit, temp_link.elasticity, temp_link.colour, temp_link.status);
                     
                        temp_link2 = pw_to.link_manager.entity_link[pw_to.link_manager.number_of_links - 1];
                        temp_link2.setInitialLength(temp_link.lower_length_limit, temp_link.target_length);
                     }
                  }
               }
            }
         }
      
         creature_manager.moveCreaturesBetweenWorlds(pw_from, pw_to, initial_entity_number); // entity list needs updating!
         killSpecifiedPrivateWorld(pw_from);
      }
   	*/
   
   
      final static void killNumberedPrivateWorld(int n) {
         temp_private_world = private_world[n];
         // temp_private_world.scrub();
         private_world[n] = private_world[number_of_private_worlds - 1];
      	// Amazingly, this doesn't fix it...
         private_world[--number_of_private_worlds] = temp_private_world;
      }
   
   
      final static int getNumberOfPrivateWorld(PrivateWorld pw) {
         for (temp = number_of_private_worlds; --temp >= 0; ) {
            if (private_world[temp] == pw) {
               return temp;
            } 
         }
      
         debug("PRIVATE WORLD NOT FOUND!!!");
         // do { } while (true);
         return -1; // not found...
      }
   
   
      final static void killSpecifiedPrivateWorld(PrivateWorld pw) {
         temp = getNumberOfPrivateWorld(pw);
         killNumberedPrivateWorld(temp);
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
